---
title: BaseAudioContext.createStereoPanner()
slug: Web/API/BaseAudioContext/createStereoPanner
tags:
  - API
  - AudioContext
  - BaseAudioContext
  - Media
  - Method
  - Reference
  - Web Audio API
  - createStereoPanner
---
<p>{{ APIRef("Web Audio API") }}</p>

<div>
<p>The <code>createStereoPanner()</code> method of the {{ domxref("BaseAudioContext") }} interface creates a {{ domxref("StereoPannerNode") }}, which can be used to apply stereo panning to an audio source. It positions an incoming audio stream in a stereo image using a low-cost <a class="external external-icon" href="https://webaudio.github.io/web-audio-api/#equal-power">equal-power</a> panning algorithm.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">baseAudioContext.createStereoPanner();</pre>

<h3 id="Description">Returns</h3>

<p>A {{domxref("StereoPannerNode")}}.</p>

<h2 id="Example">Example</h2>

<p>In our <a href="https://mdn.github.io/webaudio-examples/stereo-panner-node/">StereoPannerNode example</a> (<a href="https://github.com/mdn/webaudio-examples/tree/master/stereo-panner-node">see source code</a>) HTML we have a simple {{htmlelement("audio")}} element along with a slider {{HTMLElement("input")}} to increase and decrease pan value. In the JavaScript we create a {{domxref("MediaElementAudioSourceNode")}} and a {{domxref("StereoPannerNode")}}, and connect the two together using the <code>connect() </code>method. We then use an <code>oninput</code> event handler to change the value of the {{domxref("StereoPannerNode.pan")}} parameter and update the pan value display when the slider is moved.</p>

<p>Moving the slider left and right while the music is playing pans the music across to the left and right speakers of the output, respectively.</p>

<pre class="brush: js">var audioCtx = new (window.AudioContext || window.webkitAudioContext)();
var myAudio = document.querySelector('audio');

var panControl = document.querySelector('.panning-control');
var panValue = document.querySelector('.panning-value');

pre.innerHTML = myScript.innerHTML;

// Create a MediaElementAudioSourceNode
// Feed the HTMLMediaElement into it
var source = audioCtx.createMediaElementSource(myAudio);

// Create a stereo panner
var panNode = audioCtx.createStereoPanner();

// Event handler function to increase panning to the right and left
// when the slider is moved

panControl.oninput = function() {
  panNode.pan.setValueAtTime(panControl.value, audioCtx.currentTime);
  panValue.innerHTML = panControl.value;
}

// connect the MediaElementAudioSourceNode to the panNode
// and the panNode to the destination, so we can play the
// music and adjust the panning using the controls
source.connect(panNode);
panNode.connect(audioCtx.destination);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-baseaudiocontext-createstereopanner', 'createStereoPanner()')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>
<div>

<p>{{Compat("api.BaseAudioContext.createStereoPanner")}}</p>
</div>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
